﻿#include <iostream>
#include <vector>
#include "Functions.h"


void printMenu() {
    std::cout << std::endl << "---------------------------- M E N U ----------------------------" << std::endl << std::endl
        << "1. Create a file with a file stream" << std::endl
        << "2. Create a file with stream iterators and GENERATE algorithm" << std::endl
        << "3. Load data in a container with a file stream" << std::endl
        << "4. Load data in a container with a stream iterator and COPY algorithm" << std::endl
        << "5. Modify1 " << std::endl
        << "6. Modify2 " << std::endl
        << "7. Modify3 " << std::endl
        << "8. Modify4 " << std::endl
        << "9. OutputResult() file streams" << std::endl
        << "10. OutputResult() stream iterators" << std::endl
        << "0 - Exit " << std::endl << std::endl;
}

int main() {
    int option = 1;
    std::vector<int> vec;

    while (option != 0) {
        printMenu();

        std::cout << "Enter a number: " << std::endl;
        std::cin >> option;

        switch (option) {

        case 1:
        {
            CreateData_file("file1");
        }
        break;

        case 2:
        {
            CreateData_iter<std::vector<int>>("file2");
        }
        break;

        case 3:
        {
            LoadData_file<std::vector<int>>(vec, "file2");
            container_printout(vec);
        }
        break;

        case 4:
        {
            LoadData_iter(vec, "file2");
            container_printout(vec);
        }
        break;

        case 5:
        {
            Modify_1(vec);
            container_printout(vec);
        }
        break;

        case 6:
        {
            Modify_2(vec.begin(), vec.end());
            container_printout(vec);
        }
        break;

        case 7:
        {
            Modify_3(vec);
            container_printout(vec);
        }
        break;

        case 8:
        {
            Modify_4<std::vector<int>>("modif_4");
            outputResult_iter<std::vector<int>>("modif_4", vec);
        }
        break;

        case 9:
        {
            outputResult_file("result", vec);
        }
        break;

        case 10:
        {
            outputResult_iter<std::vector<int>>("result", vec);
        }
        break;

        default:
            std::cout << std::endl << std::endl << "I don't know such a command... Try again please." << std::endl << std::endl;
            break;
        }
    }
    return 0;
}

